#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct TaggedInterval {
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "start", skip_serializing_if = "Option::is_none", default)]
    start: Option<Box<super::super::super::super::super::api::Timestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "end", skip_serializing_if = "Option::is_none", default)]
    end: Option<Box<super::super::super::super::super::api::Timestamp>>,
    #[builder(default, map(key(type = String, into), value(type = String, into)))]
    #[serde(
        rename = "tags",
        skip_serializing_if = "std::collections::BTreeMap::is_empty",
        default
    )]
    tags: std::collections::BTreeMap<String, String>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(
        rename = "timeShiftAnchor",
        skip_serializing_if = "Option::is_none",
        default
    )]
    time_shift_anchor: Option<Box<super::super::super::super::super::api::Timestamp>>,
}
impl TaggedInterval {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn start(&self) -> Option<&super::super::super::super::super::api::Timestamp> {
        self.start.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn end(&self) -> Option<&super::super::super::super::super::api::Timestamp> {
        self.end.as_ref().map(|o| &**o)
    }
    /// Tags to inject for this interval. Guaranteed to match `TagByIntervalsSeriesNode.tagKeys`.
    #[inline]
    pub fn tags(&self) -> &std::collections::BTreeMap<String, String> {
        &self.tags
    }
    /// When time shift is enabled, the instant subtracted from each point in this interval's slice.
    /// Omitted when time shift is off.
    #[inline]
    pub fn time_shift_anchor(
        &self,
    ) -> Option<&super::super::super::super::super::api::Timestamp> {
        self.time_shift_anchor.as_ref().map(|o| &**o)
    }
}
